/*
===============================================================================
 Name        : main.c
 Author      : 
 Version     :
 Copyright   : Copyright (C) 
 Description : main definition
===============================================================================
*/
#ifdef __USE_CMSIS
#include "LPC17xx.h"
#endif
#include <cr_section_macros.h>
#include <NXP/crp.h>
// Variable to store CRP value in. Will be placed automatically
// by the linker when "Enable Code Read Protect" selected.
// See crp.h header for more information
__CRP const unsigned int CRP_WORD = CRP_NO_CRP ;
// TODO: insert other include files here
//==============================================================
//__sys_istty __sys_flen =>Redlib(newlib) semihost (nohost none) =>settings toolsettings target
#include "LPC176x.h"
#include "pinout.h"
#include "defines.c"
#include "spi_ssp.h"
#include "rtc.h"
#include "start.h"

#include "glcd.h"
#include "touch.h"
#include "uart176x.h"

#include "x_i2c.h"
#include "pwm.h"
#include "pwm_c.h"

#include "mmc_ssp.h"
#include "ff.h"
#include "startfat.h"
#include "kk_sd.h"
//#include "SPI_MSD_Driver.h"



// TODO: insert other definitions and declarations here
#define sd 1
uint8_t texttmp[]={'!','F','P','t','1','2','3','4','5','\0'};
	  // Private variables ---------------------------------------------------------//

	  FATFS fs;         // Work area (file system object) for logical drive //
	  FIL fsrc;         // file objects //
	  FRESULT res;
	  UINT br;

	  char path[512]="0:";
	  uint8_t textFileBuffer[] = "Thank you for using LPC1768-Mini-DK Development Board £¡^_^ \r\n";

	  // Private function prototypes -----------------------------------------------//
	  int SD_TotalSize(void);
	  void USART_Configuration(void);
	  FRESULT scan_files (char* path);


	  void  Delay (uint32_t nCount)
	  {
	    for(; nCount != 0; nCount--);
	  }

 /**/


// TODO: insert other definitions and declarations here
	  //////////////////////////////////////////////////////////////////////////
//i2c
	  ///////////////////////////////////////////////////////////////////////////

	  ///////////////////////////////////////////////////////////////////////////
	  ///////////////////////////////////////////////////////////////////////////
#define CHANNEL_NUM			1
extern volatile uint32_t match_counter1;

int main(void) {
	u8 min_alt;

	init_led();
	led_off;
	LCD_Initializtion();
	//	  LCD_Clear(Yellow);
	LCD_Clear(Olive);
//	lgw(1,1,"test");
	LCD_regionSTRING(1,1,"LPC1769",Red,Yellow,0,3);
//wait;wait;
interrupt_pins_init();//1+2+4


	u32 pll0_clk_f;
	u8 N=((PLL0STAT>>16)&0xff)+1;
	u32 M=(PLL0STAT&0x00003fff)+1;
	pll0_clk_f=(2*M*12000000)/N;//400mhz

	lgi(3,1,N);//6
	lgi(4,1,M);//100
	lgi(5,1,pll0_clk_f);//12MHZ
	lgi(6,1,CCLKCFG+1);//4
	lgi(7,1,SystemCoreClock);
u8 pwm1_clk_sel = (PCLKSEL0>>12)&3;
	lgi(8,1,pwm1_clk_sel);


//+++ pwm +++
	uint32_t cycle = 2540, ozlmult=20,mult=10;
	uint16_t offsetx[8]={4,7,10,15,20,25,30,35};
	u8 ozl=5;
if ( PWM_Init( CHANNEL_NUM, 0 ) != TRUE ){while( 1 );	}
pwm1_clk_sel = (PCLKSEL0>>12)&3;
lgi(9,1,pwm1_clk_sel);
 PWM_Set( CHANNEL_NUM, cycle*mult, offsetx[ozl]*ozlmult*mult );
//--- pwm ---





//++++ i2c +++
	u32 i,test=0;
	I2C1Init();
//	i2c1_scan(150);
//ok
	eep24c_wr(0x0012,1234);
	test=eep24c_rd(0x0012);
lgi(6,1,test);lw(" ");
//hou=21;min=39;DAY=19;MON=8;YEA=13;ds1307_wr();
ds1307_rd();
// Defines values for the RTC
MIN=min;
SEC=sec;
HOUR=hou;
DOM =23;
MONTH=MON;
YEAR=YEA;
lgi(5,1,hou);lw(":");li(min);lw(":");li(sec);lw("-");li(DOM);lw(".");li(MONTH);lw(".");li(YEAR);
//--- i2c ----


	lgi(7,1,SystemCoreClock);
//	led_tog;
	init_touch();
	tastatur_4x4();
	vF_SysTickInit(100000000, 10);

	RTCInit();
	 RTCStart();
	 CIIR|=IMSEC;//sec-interrupt
	 NVIC_EnableIRQ(RTC_IRQn);
	 ILR |= ILR_RTCCIF;		// clear interrupt flag //

//	interrupt_pins_init();
	 tast_pin_init(0,10);
//	 out_pin_init(1,18);

//	 __enable_irq();


	 uart0_init();
	// TODO: insert code here
//wait;wait;
	// TODO: insert code here
//+++++++++++++ sd ++++++++++++++++++
/*	 res=f_mount(0, &fs);
	 mp3_anz_verzeichnisse=fat_subdirselect(99);
	 fat_subdirshow(5,8);
*/
//------------- sd ------------------

	 //++++++++++++ adc ++++++++++++++
	 // PCADC / PCAD
PCONP |= (1UL<<12);    // Power control for peripherals (PCONP)
pinSEL(0,24,1);// Config Pin for AD0.x
LPC_ADC->ADCR       |=  (1UL<< 1);//select ad0.x
//LPC_ADC->ADCR       |=  (1UL<< 8);  // AD0CR15:8 clockdiv is MHz/clockdiv+1
LPC_ADC->ADCR       |=	(1UL<<21); // enable ADC
//-------------------------------
u8	 tast1=1,tast1alt=1,pulse_an=2,automatik=1,sperre=0;
u32 adval=0;

 __enable_irq();

//++++++++++ while ++++++++++++++
while(1) {


if (TP_INT_IN==0 ){
getDisplayPoint(&display, Read_Ads7846(), &matrix ) ;
		//lgi(5,1,display.x);lw("x");
		//lgi(6,1,display.y);lw("x");
TP_DrawPoint(display.x,display.y);
	if(tp_tasteNR<255){
	switch(tp_tasteNR){
		case 0x02:automatik=1;break;
		case 0x03:automatik=0;break;
		case 0x12:if(mult<10000)mult=mult+1;break;
		case 0x13:if(mult>1)mult=mult-1;break;
		case 0x22:k29_0dauer_1pulse=1;break;
		case 0x23:k29_0dauer_1pulse=0;break;
		case 0x32:ozl++;if(ozl>7)ozl=7;break;
		case 0x33:ozl--;if(ozl>250)ozl=0;break;
	}
PWM_Set( CHANNEL_NUM, cycle*mult, offsetx[ozl]*ozlmult*mult );

tp_tasteNR=255;}
}

		//+++out pulse
/*		if (zl_anaus<pulse_an){
		led_on;
		out1_on;
		}else{
		led_off;
		out1_off;
		}
		if (zl_anaus>(pulse_an+pulse_aus))zl_anaus=0;
		//---out pulse
*/


		//++++ adc ++++
		// Start A/D conversion for on AD0.0
	/*	AD0CR = START_ADC | OPERATIONAL_ADC | SEL_AD0 ;

		do {
			adval = AD0GDR;                      // Read A/D Data Register
		} while ((adval & ADC_DONE_BIT) == 0);   // Wait for end of A/D Conversion

		AD0CR &= ~(START_ADC | OPERATIONAL_ADC | SEL_AD0 );   // Stop A/D Conversion
*/

LPC_ADC->ADCR |=  (1<<24);                               // start conversion
while (!(LPC_ADC->ADGDR & (1UL<<31)));                   // Wait for Conversion end
adval = ((LPC_ADC->ADGDR >> 4) & 0xFFF);                   // read converted value
LPC_ADC->ADCR &= ~(7<<24);                               // stop conversion


		 // Extract AD0.0 value - 12 bit result in bits [15:4]

//		printf ("%d - Pot val = %d\n", i, adval);
//		main_delay(5000);	//Short delay before doing another ADC read
//wait;
i++ ;


		//---- adc ----




//++++++++Drehzahl++++++++

if(automatik==1){
	//zu langsam
	if(timerDrehzahl>52 && sperre==0){ozl++;sperre=1;}
	if(timerDrehzahl>70 && sperre==1){ozl++;sperre=2;}
//	if(timerDrehzahl>62)ozl++;
//	if(timerDrehzahl>72)ozl++;
//	if(timerDrehzahl>82)ozl++;
				if(ozl>7)ozl=7;
}
tast1=pinVAL(0,10);
if(tast1!=tast1alt){//Wechsel  on off
	tast1alt=tast1;

	if(tast1){//off
	lcd_goto(10,1);
		if(automatik==1){
			//zu langsam

				//zu schnell
				if(timerDrehzahl<48)ozl--;
				if(ozl>200)ozl=0;
			PWM_Set( CHANNEL_NUM, cycle*mult, offsetx[ozl]*ozlmult*mult );
			sperre=0;
		}


//lgi(1,20,pulse_aus); lcd_write(" ");
	lcd_goto(10,1);

	k29_zl_naehstiche++;
	if(k29_0dauer_1pulse==1 && k29_zl_naehstiche>10){
		k29_zl_naehstiche=0;
//		k29_0dauer_1pulse=1;
		LCD_Clear(0x001F);
		k29pause=1;
		PWM_Stop( 1 );
		tastatur_4x4();
	}


	}
	else//on
	{lcd_goto(10,10);}

	 lcd_int(timerDrehzahl);
	 lcd_write(" ");
	 _delay_ms(10);
	 timerDrehzahl=0;

	 led_tog;
}
//-------- Drehzahl ----------


//		lgi(1,5,2);

		//++++++++++++ min ++++++++++++++++++
			if(sec_alt!=SEC){sec_alt=SEC;
			lcd_rtc_sec();

			lgi(1,20,ozl);lw("/");
			lgi(2,20,automatik);lw("_auto");
			lgi(3,20,mult);lw("_freq");

			lcd_goto(9,1);
			 lcd_int(i);
			 lcd_write(": ");
			 lcd_int(adval);
			 lcd_write(" ");
i=0;
		//++++++++++++ min ++++++++++++++++++
			if(min_alt!=MIN){min_alt=MIN;
			lcd_timex();



		if(HOUR==3 || gbi(bool_menu, mn_programmstart)==0)
			auto_sommerzeit();
		}//min
		}//sec
		sbi(bool_menu, mn_programmstart);

	}
	return 0 ;
}
//====================================
